/*
 * golombCoding.h
 *
 *  Created on: Jan 30, 2009
 *      Author: jonathanmasci
 */

#ifndef GOLOMBCODING_H_
#define GOLOMBCODING_H_

#include <vector>

class GolombCoding {
public:
  GolombCoding(unsigned char *input, unsigned int length, unsigned int M);
  virtual ~GolombCoding();
  void encode();
  unsigned char *decode(unsigned int *out_len);
  long getBitSizeEstimation();
private:
  unsigned char *_input;
  unsigned int _length;
  unsigned int _M;
  std::vector<bool> _bitVector;
  bool _isPowerOfTwo;
};

#endif /* GOLOMBCODING_H_ */
